org.apache.commons.math.ode.sampling

## Interface StepHandler

- All Known Implementing Classes:
    ContinuousOutputModel, DummyStepHandler, FirstOrderIntegratorWithJacobians.StepHandlerWrapper, MultistepIntegrator.NordsieckInitializer, StepNormalizer

      public interface StepHandler

  This interface represents a handler that should be called after each successful step.

  The ODE integrators compute the evolution of the state vector at some grid points that depend on their own internal algorithm. Once they have found a new grid point (possibly after having computed several evaluation of the derivative at intermediate points), they provide it to objects implementing this interface. These objects typically either ignore the intermediate steps and wait for the last one, store the points in an ephemeris, or forward them to specialized processing or output methods.

  Since:
    1.2
  Version:
    $Revision: 1073158 $ $Date: 2011-02-21 22:46:52 +0100 (lun. 21 févr. 2011) $
  See Also:
    `FirstOrderIntegrator`, `SecondOrderIntegrator`, `StepInterpolator`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `handleStep(StepInterpolator interpolator, boolean isLast)` Handle the last accepted step
    `boolean` | `requiresDenseOutput()` Determines whether this handler needs dense output.
    `void` | `reset()` Reset the step handler.

- - ### Method Detail

    - #### requiresDenseOutput

          boolean requiresDenseOutput()

      Determines whether this handler needs dense output.

      This method allows the integrator to avoid performing extra computation if the handler does not need dense output. If this method returns false, the integrator will call the `handleStep(org.apache.commons.math.ode.sampling.StepInterpolator, boolean)` method with a `DummyStepInterpolator` rather than a custom interpolator.

      Returns:
        true if the handler needs dense output

    - #### reset

          void reset()

      Reset the step handler. Initialize the internal data as required before the first step is handled.

    - #### handleStep

          void handleStep(StepInterpolator interpolator,
                        boolean isLast)
                          throws DerivativeException

      Handle the last accepted step
      Parameters:
        `interpolator` - interpolator for the last accepted step. For efficiency purposes, the various integrators reuse the same object on each call, so if the instance wants to keep it across all calls (for example to provide at the end of the integration a continuous model valid throughout the integration range, as the `ContinuousOutputModel` class does), it should build a local copy using the clone method of the interpolator and store this copy. Keeping only a reference to the interpolator and reusing it will result in unpredictable behavior (potentially crashing the application).
        `isLast` - true if the step is the last one
      Throws:
        `DerivativeException` - if user code called from step interpolator finalization triggers one

Copyright (c) 2003-2013 Apache Software Foundation